import processing.pdf.*;


//dimensions feuille
int xA4=3508;//595;
int yA4=4961;//842;

float xRatio=float(xA4)/210;
float yRatio=float(yA4)/297;
float ratio=(xRatio+yRatio)/2;

//dimension roue codeuse
float margeLat=0.85;//marge impression latérale
int nbPulsesMax=4096;
int nbBandes=10;
float largeurBande=180;//en mm (sera corrigée par le ratio par la suite
float hauteurBande=10;

float largeurTrait=10;//largeur trait (non créneau)

String nomFichier="default.pdf";



void setup() {
  
  size(xA4, yA4, PDF, nomFichier);//A4
  
}

void draw() {
  
  //calcul
  hauteurBande=hauteurBande*ratio;
  largeurBande=margeLat*xA4;
  
  nbBandes=int(height/hauteurBande);


  background(255);  
  stroke(0); //noir  
  strokeCap(SQUARE);
  
  
  pushMatrix();
  
  translate(0.5*(width-largeurBande),20);//marge à gauche et en haut
  
  for(float i=0 ; i<nbBandes/2-1;i++)//-2 pour avoir une marge en bas 
  {
    translate(0,hauteurBande*2);
    
    largeurTrait=largeurTrait/pow(3,0.25);
    //largeurTrait=1.28;
    strokeWeight(largeurTrait);
    
    pushMatrix();
    for(float j=0;j<largeurBande/(xA4/(128*(i+1)));j++)
    {
      //translate(2*largeurBande/nbPulsesMax,0);
    //translate(int(2*512/xA4),0);  
      translate(xA4/(128*(i+1)),0);  
      
      strokeWeight(largeurTrait);
      line(0,0,0,hauteurBande);
      fill(0);
      
      
      if (j%20==0)
      {
        strokeWeight(largeurTrait/3);
        line(0,-hauteurBande*.12,0,hauteurBande);
        textSize(8);
        textAlign(CENTER); 
        text(int(j),8,-hauteurBande*.1); 
      }
      
    }
    popMatrix();
     
     //texte
     
     fill(0);
     textSize(16);
     textAlign(CENTER); 
     text(nbPulsesMax/2,width/4, -hauteurBande*.25); 
     text(largeurTrait,width/2, -hauteurBande*.25);
     text(0.5*nbPulsesMax*ratio/largeurBande,3*width/4, -hauteurBande*.25);
     
    
    nbPulsesMax=int(nbPulsesMax/pow(2,0.25));
   
  }
  
  popMatrix();
  
  
  

  // Exit the program 
  println("Finished.");

  exit();
}
